/*
 *
 *
 *    muxengine.h
 *
 *    C++ header file for class my::muxengine
 *
 *    =========================================================================
 *
 *    Copyright (C) 2001-2003 by Matt Roberts, KK5JY.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    =========================================================================
 *
 *
 */


#ifndef __MUXENGINE_H
#define __MUXENGINE_H

	namespace my {
		class muxengine {
			public:

			private: /* object data */
				my::multiplex mux;

			public: /* public interface */
				int watch (timeval *timeout = 0);
                int watch (timeval &timeout);
				int watch (long &sec, long &usec);

				void add (const watchable &, ...);

			public: /* public ctors and dtors */
				muxengine (void) { /* noop */ };
				~muxengine (void) { /* noop */ };

			private: /* disallow this */
				muxengine (const muxengine &m) { };
		}
	}

	inline int my::muxengine::watch (timeval *timeout) {
		// execute base class 'watch(...)'
		int count = my::multiplex::watch (timeout);

		if (count > 0) {
			/* loop through all objects, and deal with I/O */
			for (;;) {
			}
		}

		return real_count;
	}

#endif /* __MUXENGINE_H */
